/*

    zoltan.c - ZoltanPlayer CD/MP3 Player

    Copyright (C) 2001 Angel Ortega <angel@triptico.com>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    http://www.triptico.com

*/


#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include "zoltan.h"


/*******************
	Data
********************/

#ifndef DEFAULT_CONFIG_FILE
#define DEFAULT_CONFIG_FILE "/etc/zoltan.conf"
#endif


/*******************
	Code
********************/

int main(int argc, char * argv[])
{
	int s;

	/* refuse to run as root */
	if(getuid()==0)
	{
		printf("I won't run as root, so forget it.\n");
		exit(1);
	}

	/* startup */
	if(argc > 1)
		zoltan_startup(argv[1]);
	else
		zoltan_startup(DEFAULT_CONFIG_FILE);

	/* startup server */
	s=zoltan_server_socket(_zoltan_port);

	/* set default volume */
	zoltan_set_volume();

	/* ignore broken pipes */
	signal(SIGPIPE,SIG_IGN);

	/* daemonize */
	if(fork()) exit(0);

	for(;;)
	{
		zoltan_process_connection(s);
		zoltan_poll();
		sleep(1);
	}

	return(0);
}
